# Crie uma classe Turma que:
# - Armazena alunos
# - Permite adicionar alunos
# - Permite imprimir os alunos
# - Permite imprimir os alunos aprovados
# - Permite imprimir os alunos reprovados


from estudante import Estudante


class Turma:

    def __init__(self, disciplina, codigo, estudantes=None):
        self.disciplina = disciplina
        self.codigo = codigo
        if estudantes is None:
            self.lista = []
        else:
            self.lista = estudantes.copy()

    def adiciona(self, estudante):
        self.lista.append(estudante)

    def imprime_estudantes(self):
        for estudante in self.lista:
            print(estudante)

    def imprime_aprovados(self):
        for estudante in self.lista:
            if estudante.aprovado():
                print(estudante)

    def imprime_reprovados(self):
        for estudante in self.lista:
            if not estudante.aprovado():
                print(estudante)

    def __str__(self):
        s = f"{self.disciplina}{self.codigo}\n"
        for estudante in self.lista:
            s += str(estudante) + "\n"
        return s


ana = Estudante(nome="Ana", curso=42, RA=123456, nota=7.0)
beto = Estudante(nome="Beto", curso=34, RA=123456, nota=3.0)
carlos = Estudante(nome="Carlos", curso=42, RA=123456, nota=6.0)

turma = Turma(disciplina="mc102", codigo="W", estudantes=[ana])
print(turma)

print("Depois de adicionar")
turma.adiciona(beto)
turma.adiciona(carlos)
print(turma)

print("Aprovados")
turma.imprime_aprovados()

print("Reprovados")
turma.imprime_reprovados()